Skip to content
Start here

Get Spectrum application configuration

GET/zones/{zone_id}/spectrum/apps/{app_id}

Gets the application configuration of a specific application inside a zone.

Security
API Token

The preferred authorization scheme for interacting with the Cloudflare API. Create a token.

Example:Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY
API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
Accepted Permissions (at least one required)
Zone Settings WriteZone Settings Read
Path ParametersExpand Collapse
zone_id: string

Zone identifier.

maxLength32
app_id: string

App identifier.

maxLength32
ReturnsExpand Collapse
errors: array of object { code, message, documentation_url, source }
code: number
minimum1000
message: string
documentation_url: optional string
source: optional object { pointer }
pointer: optional string
messages: array of object { code, message, documentation_url, source }
code: number
minimum1000
message: string
documentation_url: optional string
source: optional object { pointer }
pointer: optional string
success: true

Whether the API call was successful.

result: optional object { id, created_on, dns, 11 more } or object { id, created_on, dns, 3 more }
One of the following:
SpectrumConfigAppConfig = object { id, created_on, dns, 11 more }
id: string

App identifier.

maxLength32
created_on: string

When the Application was created.

formatdate-time
dns: DNS { name, type }

The name and type of DNS record for the Spectrum application.

name: optional string

The name of the DNS record associated with the application.

formathostname
type: optional "CNAME" or "ADDRESS"

The type of DNS record associated with the application.

One of the following:
"CNAME"
"ADDRESS"
modified_on: string

When the Application was last modified.

formatdate-time
protocol: string

The port configuration at Cloudflare's edge. May specify a single port, for example "tcp/1000", or a range of ports, for example "tcp/1000-2000".

traffic_type: "direct" or "http" or "https"

Determines how data travels from the edge to your origin. When set to "direct", Spectrum will send traffic directly to your origin, and the application's type is derived from the protocol. When set to "http" or "https", Spectrum will apply Cloudflare's HTTP/HTTPS features as it sends traffic to your origin, and the application type matches this property exactly.

One of the following:
"direct"
"http"
"https"
argo_smart_routing: optional boolean

Enables Argo Smart Routing for this application. Notes: Only available for TCP applications with traffic_type set to "direct".

edge_ips: optional EdgeIPs

The anycast edge IP configuration for the hostname of this application.

One of the following:
Dynamic = object { connectivity, type }
connectivity: optional "all" or "ipv4" or "ipv6"

The IP versions supported for inbound connections on Spectrum anycast IPs.

One of the following:
"all"
"ipv4"
"ipv6"
type: optional "dynamic"

The type of edge IP configuration specified. Dynamically allocated edge IPs use Spectrum anycast IPs in accordance with the connectivity you specify. Only valid with CNAME DNS names.

Static = object { ips, type }
ips: optional array of string

The array of customer owned IPs we broadcast via anycast for this hostname and application.

type: optional "static"

The type of edge IP configuration specified. Statically allocated edge IPs use customer IPs in accordance with the ips array you specify. Only valid with ADDRESS DNS names.

ip_firewall: optional boolean

Enables IP Access Rules for this application. Notes: Only available for TCP applications.

origin_direct: optional array of string

List of origin IP addresses. Array may contain multiple IP addresses for load balancing.

origin_dns: optional OriginDNS { name, ttl, type }

The name and type of DNS record for the Spectrum application.

name: optional string

The name of the DNS record associated with the origin.

formathostname
ttl: optional number

The TTL of our resolution of your DNS record in seconds.

minimum600
type: optional "" or "A" or "AAAA" or "SRV"

The type of DNS record associated with the origin. "" is used to specify a combination of A/AAAA records.

One of the following:
""
"A"
"AAAA"
"SRV"
origin_port: optional OriginPort

The destination port at the origin. Only specified in conjunction with origin_dns. May use an integer to specify a single origin port, for example 1000, or a string to specify a range of origin ports, for example "1000-2000". Notes: If specifying a port range, the number of ports in the range must match the number of ports specified in the "protocol" field.

maximum65535
minimum1
One of the following:
number
string
proxy_protocol: optional "off" or "v1" or "v2" or "simple"

Enables Proxy Protocol to the origin. Refer to Enable Proxy protocol for implementation details on PROXY Protocol V1, PROXY Protocol V2, and Simple Proxy Protocol.

One of the following:
"off"
"v1"
"v2"
"simple"
tls: optional "off" or "flexible" or "full" or "strict"

The type of TLS termination associated with the application.

One of the following:
"off"
"flexible"
"full"
"strict"
SpectrumConfigPaygoAppConfig = object { id, created_on, dns, 3 more }
id: string

App identifier.

maxLength32
created_on: string

When the Application was created.

formatdate-time
dns: DNS { name, type }

The name and type of DNS record for the Spectrum application.

name: optional string

The name of the DNS record associated with the application.

formathostname
type: optional "CNAME" or "ADDRESS"

The type of DNS record associated with the application.

One of the following:
"CNAME"
"ADDRESS"
modified_on: string

When the Application was last modified.

formatdate-time
protocol: string

The port configuration at Cloudflare's edge. May specify a single port, for example "tcp/1000", or a range of ports, for example "tcp/1000-2000".

origin_direct: optional array of string

List of origin IP addresses. Array may contain multiple IP addresses for load balancing.

Get Spectrum application configuration

curl https://api.cloudflare.com/client/v4/zones/$ZONE_ID/spectrum/apps/$APP_ID \
    -H "Authorization: Bearer $CLOUDFLARE_API_TOKEN"
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "id": "023e105f4ecef8ad9ca31a8372d0c353",
    "created_on": "2014-01-01T05:20:00.12345Z",
    "dns": {
      "name": "ssh.example.com",
      "type": "CNAME"
    },
    "modified_on": "2014-01-01T05:20:00.12345Z",
    "protocol": "tcp/22",
    "traffic_type": "direct",
    "argo_smart_routing": true,
    "edge_ips": {
      "connectivity": "all",
      "type": "dynamic"
    },
    "ip_firewall": false,
    "origin_direct": [
      "tcp://127.0.0.1:8080"
    ],
    "origin_dns": {
      "name": "origin.example.com",
      "ttl": 600,
      "type": ""
    },
    "origin_port": 22,
    "proxy_protocol": "off",
    "tls": "off"
  }
}
Returns Examples
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "id": "023e105f4ecef8ad9ca31a8372d0c353",
    "created_on": "2014-01-01T05:20:00.12345Z",
    "dns": {
      "name": "ssh.example.com",
      "type": "CNAME"
    },
    "modified_on": "2014-01-01T05:20:00.12345Z",
    "protocol": "tcp/22",
    "traffic_type": "direct",
    "argo_smart_routing": true,
    "edge_ips": {
      "connectivity": "all",
      "type": "dynamic"
    },
    "ip_firewall": false,
    "origin_direct": [
      "tcp://127.0.0.1:8080"
    ],
    "origin_dns": {
      "name": "origin.example.com",
      "ttl": 600,
      "type": ""
    },
    "origin_port": 22,
    "proxy_protocol": "off",
    "tls": "off"
  }
}